//=============================================================================
//
// file :        PseudoAxes.h
//
// description : Include for the PseudoAxes class.
//
// project :	
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _PSEUDOAXES_H
#define _PSEUDOAXES_H

#include <tango.h>
//using namespace Tango;
#include <TangoHKLAdapter.h>

/**
 * @author	$Author:  $
 * @version	$Revision:  $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace PseudoAxes_ns
{

/**
 * Class Description:
 * 
 */

/*
 *	Device States Description:
 */


class PseudoAxes: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------
	Diffractometer_ns::PseudoAxesConfig config;

	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevString	*attr_mode_read;
		Tango::DevString	attr_mode_write;
		Tango::DevBoolean	*attr_initialized_read;
		Tango::DevBoolean	attr_initialized_write;
		Tango::DevString	*attr_modeNames_read;
		Tango::DevString	*attr_parametersNames_read;
		Tango::DevDouble	*attr_parameters_read;
		Tango::DevDouble	attr_parameters_write;
		Tango::DevString	*attr_pseudoAxisNames_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	the diffractometer Proxy
 */
	string	diffractometerProxy;
/**
 *	name of the HklPseudoAxisEngine used by this device.
 */
	string	engineName;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PseudoAxes(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PseudoAxes(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	PseudoAxes(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~PseudoAxes() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name PseudoAxes methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for mode acquisition result.
 */
	virtual void read_mode(Tango::Attribute &attr);
/**
 *	Write mode attribute values to hardware.
 */
	virtual void write_mode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for initialized acquisition result.
 */
	virtual void read_initialized(Tango::Attribute &attr);
/**
 *	Write initialized attribute values to hardware.
 */
	virtual void write_initialized(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for modeNames acquisition result.
 */
	virtual void read_modeNames(Tango::Attribute &attr);
/**
 *	Extract real attribute values for parametersNames acquisition result.
 */
	virtual void read_parametersNames(Tango::Attribute &attr);
/**
 *	Extract real attribute values for parameters acquisition result.
 */
	virtual void read_parameters(Tango::Attribute &attr);
/**
 *	Write parameters attribute values to hardware.
 */
	virtual void write_parameters(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for pseudoAxisNames acquisition result.
 */
	virtual void read_pseudoAxisNames(Tango::Attribute &attr);
/**
 *	Read/Write allowed for mode attribute.
 */
	virtual bool is_mode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for initialized attribute.
 */
	virtual bool is_initialized_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for modeNames attribute.
 */
	virtual bool is_modeNames_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for parametersNames attribute.
 */
	virtual bool is_parametersNames_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for parameters attribute.
 */
	virtual bool is_parameters_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for pseudoAxisNames attribute.
 */
	virtual bool is_pseudoAxisNames_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for AxisInit command.
 */
	virtual bool is_AxisInit_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Apply command.
 */
	virtual bool is_Apply_allowed(const CORBA::Any &any);
/**
 * This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *	@return	State Code
 *	@exception DevFailed
 */
	virtual Tango::DevState	dev_state();
/**
 * This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *	@return	Status description
 *	@exception DevFailed
 */
	virtual Tango::ConstDevString	dev_status();
/**
 * Initialize the pseudoAxes (exemple the psi pseudo axis)
 *	@exception DevFailed
 */
	void	axis_init();
/**
 * Apply the values of the pseudo axes and write them on the diffractometer device.
 *	@exception DevFailed
 */
	void	apply();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	Diffractometer_ns::PseudoAxesAdapter * _adapter;
	Diffractometer_ns::TangoHKLAdapter * _hklAdapter;
};

}	// namespace_ns

#endif	// _PSEUDOAXES_H
